Bugzilla (bugzilla.redhat.com) will be under maintenance for infrastructure upgrades and will not be available on July 31st between 12:30 AM - 05:30 AM UTC. We appreciate your understanding and patience. You can follow status.redhat.com for details.
Bug 456872 - patch to get apt to build against latest rpm to clear broken dependancies
Summary: patch to get apt to build against latest rpm to clear broken dependancies
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: apt
Version: 10
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Panu Matilainen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2008-07-28 11:24 UTC by Caolan McNamara
Modified: 2008-12-23 09:15 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2008-12-23 09:15:51 UTC
Type: ---


Attachments (Terms of Use)
patch to make build (10.02 KB, patch)
2008-07-28 11:24 UTC, Caolan McNamara
no flags Details | Diff
how about this then (11.00 KB, patch)
2008-08-01 11:22 UTC, Caolan McNamara
no flags Details | Diff

Description Caolan McNamara 2008-07-28 11:24:45 UTC
Attached is a hacky patch to fix up apt to build in rawhide

Comment 1 Caolan McNamara 2008-07-28 11:24:45 UTC
Created attachment 312763 [details]
patch to make build

Comment 2 Alex Lancaster 2008-08-01 09:31:29 UTC
I tried applying this and doing a scratch koji build:

http://koji.fedoraproject.org/koji/taskinfo?taskID=752089

It appears to compile on x86_64:

http://koji.fedoraproject.org/koji/taskinfo?taskID=752091

but oddly fails on i386:

http://koji.fedoraproject.org/koji/getfile?taskID=752092&name=build.log

with:

bin/sh ../libtool --tag=CXX   --mode=compile g++ -DHAVE_CONFIG_H -I.
-I../include -I../include/apt-pkg  -DLIBDIR=\"/usr/lib\"
-DPKGDATADIR=\"/usr/share/apt\" -DLOCALEDIR=\"/usr/share/locale\"
-DAPT_DOMAIN=\"apt\" -I../lua/include -I../lua/local -I/usr/include/libxml2  
-I/usr/include/     -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions
-fstack-protector --param=ssp-buffer-size=4 -m32 -march=i386 -mtune=generic
-fasynchronous-unwind-tables -c -o rpm/rpmrecords.lo rpm/rpmrecords.cc
rpm/rpmpm.cc: In member function 'virtual bool
pkgRPMLibPM::Process(std::vector<const char*, std::allocator<const char*> >&,
std::vector<const char*, std::allocator<const char*> >&, std::vector<const
char*, std::allocator<const char*> >&)':
rpm/rpmpm.cc:907: error: invalid conversion from 'void* (*)(const void*,
rpmCallbackType, rpmCallbackSize_t, rpmCallbackSize_t, const void*, void*)' to
'void* (*)(const void*, rpmCallbackType, rpm_loff_t, rpm_loff_t, const void*,
void*)'
rpm/rpmpm.cc:907: error:   initializing argument 2 of 'int
rpmtsSetNotifyCallback(rpmts_s*, void* (*)(const void*, rpmCallbackType,
rpm_loff_t, rpm_loff_t, const void*, void*), void*)'
make[1]: *** [rpm/rpmpm.lo] Error 1
make[1]: *** Waiting for unfinished jobs....
 g++ -DHAVE_CONFIG_H -I. -I../include -I../include/apt-pkg -DLIBDIR=\"/usr/lib\"
-DPKGDATADIR=\"/usr/share/apt\" -DLOCALEDIR=\"/usr/share/locale\"
-DAPT_DOMAIN=\"apt\" -I../lua/include -I../lua/local -I/usr/include/libxml2
-I/usr/include/ -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions
-fstack-protector --param=ssp-buffer-size=4 -m32 -march=i386 -mtune=generic
-fasynchronous-unwind-tables -c rpm/rpmrecords.cc  -fPIC -DPIC -o
rpm/.libs/rpmrecords.o
In file included from rpm/rpmrecords.h:24,
                 from rpm/rpmrecords.cc:22:
rpm/rpmhandler.h:66: warning: 'int_32' is deprecated (declared at
/usr/include/rpm/rpmlegacy.h:18)
make[1]: Leaving directory `/builddir/build/BUILD/apt-0.5.15lorg3.94/apt-pkg'
make: 


Comment 3 Axel Thimm 2008-08-01 09:43:29 UTC
Looks like rpmCallbackSize_t and rpm_loff_t have different sizes on 32 bits.

Comment 4 Caolan McNamara 2008-08-01 11:22:41 UTC
Created attachment 313187 [details]
how about this then

Comment 5 Axel Thimm 2008-08-01 16:01:04 UTC
Thanks Caolan, I queued in a rawhide build. I guess the patch will need some #if
protection guards for using on previous Fedoras, but most probably Panu has even
some work underway on the next upstream apt version.


Comment 6 Panu Matilainen 2008-09-20 10:19:50 UTC
Thanks for massaging it to build :) I indeed have upstream work underway, it's just been stalled for age and a half due to being busy with rpm itself. Apt is going to need quite a bit of massaging to keep it building + working across all the dozen different rpm versions and variants out of the box... One major issue is the embedded Lua - there's a nasty version clash between what's bundled in apt and what rpm 4.6 is build against, causing apt to blow up if built with Lua enabled currently.

Comment 7 Axel Thimm 2008-11-09 20:22:05 UTC
Should this be CLOSEd UPSTREAM?

Comment 8 Bug Zapper 2008-11-26 02:36:22 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 10 development cycle.
Changing version to '10'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 9 Panu Matilainen 2008-12-23 09:15:51 UTC
Rawhide now has actually working apt again finally. Need to push it to F10 soonish too...


Note You need to log in before you can comment on or make changes to this bug.